
import java.util.Scanner;

public class FinalHw
{

	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		System.out.println("Please enter the number of students in the class: ");
		int numberOfStudents = sc.nextInt();
		int choice;
		double[] studentscore = new double[numberOfStudents];
		String[] studentName = new String[numberOfStudents];
		String temp = sc.nextLine();
		for (int i = 0; i < studentName.length; i++)
		{
			System.out.println("Enter the name and score of student# " + (i + 1) + " in your class. ");
			System.out.print("Name: ");
			studentName[i] = sc.next();
			System.out.print("Score: ");
			studentscore[i] = sc.nextInt();
			temp = sc.nextLine();
		}do
		{
			System.out.println("*********Menu*********");
			System.out.println("1. Show all students list");
			System.out.println("2. Show mean,median,mode");
			System.out.println("3. Find students name");
			System.out.println("4. Show score that higher than mean");
			System.out.println("5. Exit");
			System.out.println("*********************");
			System.out.println("Please enter your choice:");

		     choice = sc.nextInt();

			switch(choice)
			{
			case 1:				
				displaylist(studentName, studentscore);
			break;
			case 2:
				System.out.println("Mean: " + mean(studentscore));
				System.out.println("Median: " + median(studentscore));
				System.out.println("Mode: " + mode(studentscore));
			break;
			case 3:
				System.out.println("Enter the name of the students that you want to know their score");
				String sname = sc.nextLine();

				FindName(studentName, sname, studentscore);
			break;
			case 4:
				highscore(studentName, studentscore);
			break;
		
			case 5:
			System.out.println("You have chose exit!");
			break;
			
			default:
				System.out.println("You entered an invalid choice");
			}

			}while(choice != 5);


	}

	public static void BubbleSort(double[] num)
	{
		int j;
		boolean flag = true;
		int temp;

		while (flag)
		{
			flag = false;
			for (j = 0; j < num.length - 1; j++)
			{
				if (num[j] < num[j + 1])
				{
					temp = (int) num[j];
					num[j] = num[j + 1];
					num[j + 1] = temp;
					flag = true;
				}
			}
		}
	}

	public static double mean(double[] m)

	{
		double sum = 0;
		for (int i = 0; i < m.length; i++)
		{
			sum += m[i];
		}
		return sum / m.length;
	}

    public static void highscore(String[] name, double[] score)
	{
		System.out.println("The students that got score higher than mean");
		double m = mean(score);
		System.out.println("Mean: " + m);
		for (int i = 0; i < score.length; i++)
		{
			if (score[i] >= m)
			{
				System.out.println(name[i]);
				System.out.println(score[i]);
			}

		}
	}

	public static double median(double[] m)
	{
		BubbleSort(m);
		int middle = m.length / 2;
		if (m.length % 2 == 1)
		{
			return m[middle];
		} else
		{
			return (m[middle - 1] + m[middle]) / 2.0;
		}
	}

	public static double mode(double[] m)
	{

		int max = 0, maxCount = 0;
		int length = m.length;
		for (int i = 0; i < length; ++i)
		{
			int count = 0;
			for (int j = 0; j < length; ++j)
			{

				if (m[j] == m[i])
					++count;
			}
			if (count > maxCount)
			{
				maxCount = count;
				max = (int) m[i];
			}
		}
		return max;
	}

	public static void displaylist(String[] name, double[] score)
	{

		System.out.println("Name    Score");
		for (int i = 0; i < name.length; i++)
		{
			System.out.println(name[i] + "\t" + score[i]);
		}
	}

	public static int SeqSearch(String[] name, String key)

	{
		int met = -1;
		for (int i = 0; i < name.length; i++)
			if (name[i].equals(key))
			{
				met = i;
				break;
			}
		return met;
	}

	public static void FindName(String[] name, String sname, double[] score)
	{
		int index = SeqSearch(name, sname);
		if (index != -1)
		{
			System.out.println(name[index] + " get " + score[index]);
		} else
		{
			System.out.println("Not found!");
		}
	}

}
